Nim Game

Minimax, Brainteaser

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

Example:

Input:
4
Output:
 false 

Explanation: 
If there are 4 stones in the heap, then you will never win the game;
             No matter 1, 2, or 3 stones you remove, the last stone will always be 
             removed by your friend.

Solution

From LeetCode solution:

You can _always _win a Nim game if the number of stonesnnin the pile is not divisible by 4.

Reasoning

Let us think of the small cases. It is clear that if there are only one, two, or three stones in the pile, and it is your turn, you can win the game by taking all of them. Like the problem description says, if there are exactly four stones in the pile, you will lose. Because no matter how many you take, you will leave some stones behind for your opponent to take and win the game. So in order to win, you have to ensure that you never reach the situation where there are exactly four stones on the pile on your turn.

Similarly, if there are five, six, or seven stones you can win by taking just enough to leave four stones for your opponent so that they lose. But if there are eight stones on the pile, you will inevitably lose, because regardless whether you pick one, two or three stones from the pile, your opponent can pick three, two or one stone to ensure that, again, four stones will be left to you on your turn.

It is obvious that the same pattern repeats itself for n=4,8,12,16,…, basically all multiples of 4.

@ yangwuqi:

所以说成中文就是,如果开始的石头数量能被4整除,那么第二个人只需要始终保持每个回合的两人石头总数为4,第二个人就一定能赢,因为这样的话最后都能变成留四个石头给第一个人的情况。第二个人就必胜。

而当石头数量不能被4整除的时候,情况刚好相反,只要第一个人的第一步选择了n%4的石头,那么留给第二个人的石头数量就是4的倍数,最后留给第二个人的石头数量将是4,第一个人就必胜。

所以,总结来说,当开始的石头总数能被4整除的时候,第一个人必输,反之必胜。

class Solution {
    public boolean canWinNim(int n) {
        return (n % 4 != 0);
    }
}

Reference

http://www.cnblogs.com/grandyang/p/4873248.html

Last updated